/*global window, rJS, RSVP, console */
/*jslint nomen: true, indent: 2, maxerr: 3*/
(function (window, rJS) {
  "use strict";

  rJS(window)
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.props.element = element;
          g.props.start_deferred = RSVP.defer();
        });
    })
    //////////////////////////////////////////////
    // acquired methods
    //////////////////////////////////////////////
    .declareAcquiredMethod("getUrlFor", "getUrlFor")
    .allowPublicAcquisition("getUrlFor", function (argument_list) {
      return this.getUrlFor(argument_list[0]);
    })
    .declareAcquiredMethod("crib_sw_get", "crib_sw_get")
    .allowPublicAcquisition("crib_sw_get", function (argument_list) {
      return this.crib_sw_get(argument_list[0]);
    })
    .declareAcquiredMethod("crib_sw_put", "crib_sw_put")
    .allowPublicAcquisition("crib_sw_put", function (argument_list) {
      return this.crib_sw_put(argument_list[0], argument_list[1]);
    })
    .declareAcquiredMethod("crib_sw_getScope", "crib_sw_getScope")
    .declareMethod('render', function (options) {
      var gadget = this;
      if (options === undefined)
        options = {};
      gadget.props.options = options;
      return new RSVP.Queue()
        .push(function () {
          return gadget.props.start_deferred.resolve();
        })
        .push(function () {
          return RSVP.all([
            gadget.getDeclaredGadget("zip_loader"),
            gadget.crib_sw_getScope()
          ]);
        })
        .push(function (result_list) {
          var url_list_scope_link = gadget.props.element
            .querySelector("a.url-list-scope");
          gadget.props.scope = result_list[1];
          url_list_scope_link.href = gadget.props.scope;
          url_list_scope_link.innerHTML = gadget.props.scope
            .split("//")[1].split(".")[0];

          return result_list[0].render();
        });
    });
}(window, rJS));